=== src/examples/CMakeLists.txt ===
add_subdirectory(image-processing-examples)
add_subdirectory(io-examples)
add_subdirectory(unsorted-examples)
add_subdirectory(constrained-graphical-models-examples)
