=== debian/changelog ===
opengm (2.3.6+20160905-1+rpi1) buster-staging; urgency=medium

  [Changes taken from 2.3.6+20160905-1ubuntu1 by Dimitri John Ledkov <xnox@ubuntu.com>]
  * Disable python wrapper, as it is not ported to boost numpy.

 -- Peter Micheal Green <plugwash@raspbian.org>  Thu, 20 Dec 2018 18:55:05 +0000
