=== debian/control ===
Source: opengm
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               libboost-dev,
               libboost-graph-dev,
               libboost-python-dev,
               libhdf5-dev,
               python,
               python-nose,
               python-numpy
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/opengm.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/opengm.git
Homepage: http://hci.iwr.uni-heidelberg.de/opengm2/
X-Python-Version: >= 2.6

Package: libopengm-bin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command line tools for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the commandline interface to the OpenGM library.

Package: libopengm-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Suggests: libopengm-doc
Description: C++ template library for discrete factor graph models
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the development headers for the OpenGM library.

Package: libopengm-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: documentation and examples for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the API documentation and example source code for the
 OpenGM library.
